; TIP1107.LSP: SB.LSP   Scale Blocks  (c)1995, Richard Machmer

; Program SB SCALEs up a group of named blocks by a user supplied factor

(defun getdata ()  ; get user input
   (setq E (getstring "\nEnter name of entity to be scaled :"))
   (setq SF (getreal "\nNow enter scale factor :"))
) ;end getdata

(defun getss ()  ; make the selection set
   (setq L (cons 2 E))
   (setq SS (ssget "X" (list L)))
) ; end getss

(defun scgr ()  ; scale the group of blocks
   (if (= SS 'nil) ; if theres nothing in the selection set, do...
      (progn
         (princ "\nblock: ")
         (princ E)
         (princ " not found")
         (princ)
      ); end progn
      ; else, if there is something in the ss, do....
      (progn
         (setq C (- (sslength SS) 1))  ; set counter to number entities in ss
         (while (>= C 0)               ; while there are entities in the list
            (setq ENAME (ssname SS C)) ; get the next entity name
            (setq ENT (entget ENAME))  ; use name to get the next entity in list
            (setq IP (cdr (assoc 10 ENT))) ; get the insert pt of this entity
            (command "scale" ENAME "" IP SF)  ; scale up/down
            (command)
            (setq C (- C 1))
         ) ; end while
         (princ "\ndone...")
      );end progn
   );end if
) ; end scgr

; Body of program SB
(defun C:SB ()
   (getdata)    ;get block name & scale
   (getss)      ;make the selection set
   (scgr)       ;loop through the ss, scaling each entity
   (princ)
) ;end sb.lsp
