; TIP1104.LSP: IMPORTXT.LSP   Import Text with Columns  (c)1995, Raymond Beck

(defun RTD (ANGG)
(/ (* ANGG 180.0) pi))
;
(defun c:IMPORTXT (/ ECH I FLN FILE TXTSP PT1 NEOF STY TB SIZ HGT ROT) 
   (setq ECH (getvar "CMDECHO"))                               ;get var
   (setvar "CMDECHO" 0)                                        ;set var
   (setq I 1)                                                  ;set var
   (while I                                                    
      (setq FLN (getfiled "Select a file to import: " "" "" 4))
      (if FLN                                                   ;check for file
         (progn                                                  ;do:
            (setq FILE (open FLN "r"))                           ;open file
            (setq I nil)                                         ;cannot find file
         )                                                       ;end progn
         (prompt "\nFile does not exist or cannot find/read")
      )                                                         ;end if
   )                                                           ;end while 
   (setq PT1 (getvar "lastpoint"))                             ;reference point
   (setq PT1 (getpoint "\nPick Starting point: "))
   (setq STY (getvar "textstyle"))                             ;current style
   (prompt "\nCurrent text style is: ")(prin1 STY)             ;list style
   (setq STY1 (getstring "\nEnter text style or <ENTER> for existing style: " ))
   (if (/= STY1 "") (command "text" "style" STY ^c))           ;default to current
   (setq TB (tblsearch "style" STY))                            ;get current style
   (setq SIZ (cdr (assoc 40 TB)))                              ;get text size
   (if (= siz 0.0)                                             ;check height
      (progn                                                    ;do if hight 0.0
         (princ "\nEnter text height: <") (princ (getvar"textsize")) (princ">: ")
         (setq HGT (getdist PT1))                               ;get height
         (if (= HGT nil)  (setq HGT (getvar "textsize")))       ;default height
      )                                                         ;end progn
   )                                                           ;end if
   (setq ROT (getangle "\nEnter text rotation <0>: "))          ;get rotation
   (if (= ROT nil) (setq ROT 0))                                ;default rotation
   (setq ROT (rtd ROT))                                         ;calc rotation
   (setq TXTSP (getdist PT1 "\nEnter distance between lines: <auto>: "))
   (if (= TXTSP nil) (setq tXTSP (+ (* HGT 0.619) HGT)))       ;get auto distance
   (setq NEOF "T")
   (While NEOF                                                 ;while text to read
      (setq TXT (read-line file))                             ;read a line
      (if (= TXT nil)  (setq NEOF nil))                       ;check for eof
      (if (or (= TXT "NNN") (= TXT "nnn"))                    ;** flag to break for column 
         (progn                                               ;if flag found, do:
            (setq PT1 (getpoint "\nStarting point of next column"))
            (setq PT1 (list (car PT1) (cadr PT1)))             ;calc insertion point 
            (setq TXT (read-line file))                        ;skip nnn or NNN
         )                                                    ;end progn
      )                                                       ;end if
      (if (= SIZ 0.0)  (command "text" PT1 HGT ROT TXT))      ;insert one line of file or
      (if (/= SIZ 0.0)  (command "text" PT1 ROT TXT))         ;insert one line of file
      (setq PT1 (list (car PT1) (- (cadr PT1) TXTSP)))        ;recalc next insertion point
   )                                                           ;end while
   (close FILE)                                                ;close file
   (setvar "CMDECHO" ECH)                                      ;re-set var
   (princ)                                                     ;exit cleanly
);end importxt.lsp
